//net.c
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <sys/types.h>
#include "net.h"
#include "config.h"

CSERVER cserver;
CLIENT client;
ENDPOINT endpoint;
//
struct  sockaddr_in     addr;
int                     csslistener;
pthread_t               hcssListenProcess;
pthread_mutex_t         cssServerMutex;
//режим работы приложения
u_int8_t		workmode;

/*
struct hostent *h;
struct sockaddr_in addr;
 
h = gethostbyname(szHost);
if (h == NULL) return;
memset(&addr, '\0', sizeof(addr));
addr.sin_family = AF_INET;
addr.sin_addr   = *(struct in_addr *)h->h_addr_list[0];
addr.sin_port   = htons( PORT )
*/


//начальная инициализация
void CSInit(void)
{
	//установки для сервера
	cserver.lport	= _ip_port_def;
	cserver.csmode	= _cmode_off;
	//установки для клиента
	client.port	= _ip_port_def;
	//установки для конечной точки
	endpoint.port	= _ip_port_def;
}

//сервер - старт
int CSStart(void)
{
	int	res = 0;
	//
        csslistener = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if(csslistener < 0)
                return -1;
        addr.sin_family = AF_INET;
        addr.sin_port = htons(cserver.lport);
        addr.sin_addr.s_addr = htonl(INADDR_ANY);
        memset(&addr.sin_zero, 0, 8);
        if(bind(csslistener, (struct sockaddr *)&addr, sizeof(addr)) < 0)
                return -2;
        if(listen(csslistener, _max_clients) < 0)
                return -3;
        //mutex create
        if(!(pthread_mutex_init(&cssServerMutex,NULL) == 0))
                return -4;
        //starting listen
        cserver.csflag |= _csflag_listen;
        pthread_create(&hcssListenProcess,NULL,(void*) CSListen,NULL);
        sleep(1);       //wait one secoond
        //
	return res;
}

//сервер - стоп
int CSStop(void)
{
	int	res = 0;
	//
	cserver.csflag &= (~(_csflag_listen | _csflag_cserver));
	//
	return res;
}
//сервер - прослушивание
void CSListen(void)
{
	
	while(1)
	{
	}
	pthread_exit(0);
}

